diff -urN microwindows-0.91/src/nanox/srvutil.c microwindows-0.91.g100/src/nanox/srvutil.c
--- microwindows-0.91/src/nanox/srvutil.c	2007-06-17 21:56:40.000000000 +0200
+++ microwindows-0.91.g100/src/nanox/srvutil.c	2007-06-16 17:14:45.000000000 +0200
@@ -79,7 +79,7 @@
  * as window will be mapped again momentarily (window move, resize, etc)
  */
 void
-GsWpUnrealizeWindow(GR_WINDOW *wp, GR_BOOL temp_unmap)
+GsWpUnrealizeWindow(GR_WINDOW *wp, GR_BOOL temp_unmap, /*REM*/char DoNotClear)
 {
 	GR_WINDOW	*pwp;		/* parent window */
 	GR_WINDOW	*sibwp;		/* sibling window */
@@ -101,8 +101,9 @@
 	/* set window invisible flag*/
 	wp->realized = GR_FALSE;
 
+	//*REM*/Unrealize all childs, but do not clear them since they are cleared later
 	for (childwp = wp->children; childwp; childwp = childwp->siblings)
-		GsWpUnrealizeWindow(childwp, temp_unmap);
+	  GsWpUnrealizeWindow(childwp, temp_unmap,/*REM*/GR_TRUE/*DoNotClear*/);
 
 	if (!temp_unmap && wp == mousewp) {
 		GsCheckMouseWindow();
@@ -134,6 +135,17 @@
 	 * Clear the area in the parent for this window, causing an
 	 * exposure event for it.  Take into account the border size.
 	 */
+
+/*REM*/#if defined(TRANS_COLOR)
+	/*We Do a redraw of all lower windows here:GR_MODE_WPCLEAR_UP*/
+	if(!DoNotClear)
+	  {
+	    bs = wp->bordersize;
+	    pwp = wp->parent;
+	    GsWpClearWindowUpAndDown(pwp, wp->x - pwp->x - bs, wp->y - pwp->y - bs,
+				     wp->width + bs * 2, wp->height + bs * 2, GR_TRUE/*exposure*/);
+	  }
+/*REM*/#else
 	bs = wp->bordersize;
 	pwp = wp->parent;
 	GsWpClearWindow(pwp, wp->x - pwp->x - bs, wp->y - pwp->y - bs,
@@ -149,6 +161,7 @@
 		GsExposeArea(sibwp, wp->x - bs, wp->y - bs,
 			wp->width + bs * 2, wp->height + bs * 2, NULL);
 	}
+/*REM*/#endif
 }
 
 /*
@@ -263,7 +276,7 @@
 	 * Unmap the window first.
 	 */
 	if (wp->realized)
-		GsWpUnrealizeWindow(wp, GR_FALSE);
+	  GsWpUnrealizeWindow(wp, GR_FALSE,/*REM Do clear*/GR_FALSE);
 
 	/* send destroy update event*/
 	GsDeliverUpdateEvent(wp, GR_UPDATE_DESTROY, wp->x, wp->y,
@@ -350,6 +363,10 @@
 		}
 	}
 
+
+/*REM*/	if(wp->alpha)
+/*REM*/   free(wp->alpha);
+
 	free(wp);
 }
 
@@ -411,6 +428,17 @@
 		destheight = y + height - pixmapy;
 	}
 
+/*REM*/#if defined(TRANS_COLOR)
+/*REM*/	if(destwidth > 0 && destheight > 0) {
+/*REM*/		if (wp->bgpixmapflags & GR_BACKGROUND_STRETCH) {
+/*REM FIXME:*/         GdStretchBlit(wp->psd, destx + wp->x, desty + wp->y,
+/*REM*/				destwidth, destheight, pm->psd, fromx, fromy,
+/*REM*/				pm->width, pm->height, MWROP_COPY);
+/*REM*/		} else GdBlit(wp->psd, destx + wp->x, desty + wp->y, destwidth,
+/*REM*/			destheight, pm->psd, fromx, fromy, MWROP_SRCTRANSCOPY);
+/*REM*/	}
+/*REM*/
+/*REM*/#else
 	if(destwidth > 0 && destheight > 0) {
 		if (wp->bgpixmapflags & GR_BACKGROUND_STRETCH) {
 			GdStretchBlit(wp->psd, destx + wp->x, desty + wp->y,
@@ -419,7 +447,7 @@
 		} else GdBlit(wp->psd, destx + wp->x, desty + wp->y, destwidth,
 			destheight, pm->psd, fromx, fromy, MWROP_COPY);
 	}
-
+/*REM*/#endif
 	if(wp->bgpixmapflags & (GR_BACKGROUND_TRANS|GR_BACKGROUND_STRETCH))
 		return;
 
@@ -525,14 +553,20 @@
 					fromy = 0;
 					cheight = y + height - tiley;
 				}
-				if(cwidth > width) cwidth = width;
+				//if(cwidth > width) cwidth = width;
+			        /*REM: BUGFIX*/if(cheight > height) cheight = height;
 				if(cheight > destheight) cheight = destheight;
 				cy = wp->y + tiley + fromy;
 			}
 
 			if((cwidth > 0) && (cheight > 0)) {
+/*REM*/#if defined(TRANS_COLOR)
+				GdBlit(wp->psd, cx, cy, cwidth, cheight,
+					pm->psd, fromx, fromy,MWROP_SRCTRANSCOPY );
+/*REM*/#else
 				GdBlit(wp->psd, cx, cy, cwidth, cheight,
 					pm->psd, fromx, fromy, MWROP_COPY);
+/*REM*/#endif
 			}
 		}
 	}
@@ -550,6 +584,10 @@
 {
 	if (!wp->realized || !wp->output)
 		return;
+
+	//*REM*/since we only clear a specific area, we can speed up clipping
+	/*REM*/MWRECT RToClip={x+wp->x,y+wp->y,x+wp->x+width,y+wp->y+height};
+
 	/*
 	 * Reduce the arguments so that they actually lie within the window.
 	 */
@@ -579,7 +617,7 @@
 	 * Invalidate the current graphics context since
 	 * we are changing the foreground color and mode.
 	 */
-	GsSetClipWindow(wp, NULL, 0);
+	GsSetClipWindow(wp, NULL, 0,/*REM*/&RToClip);
 	curgcp = NULL;
 
 	GdSetFillMode(GR_FILL_SOLID);
@@ -588,9 +626,23 @@
 		GdSetMode(GR_MODE_COPY);
 		GdSetForegroundColor(wp->psd, wp->background);
 		if (wp->bgpixmap) {
+//*REM*/screen driver will draw alpha values into the global alpha map.
+/*REM*/ #if defined(TRANS_COLOR)
+/*REM*/	                if ((MWA(wp->background)==0)||(wp->props & GR_WM_PROPS_APPMASK && wp->children && MWA(wp->children->background)==0))
+/*REM*/	                  GdSetAlphaChannel(wp->bgpixmap->alpha,wp->x,wp->y,wp->bgpixmap->width,wp->bgpixmap->height);
+/*REM*/                 else 
+/*REM*/	                  GdSetAlphaChannel(NULL,0,0,0,0); 
+/*REM*/ #endif
 			GsWpDrawBackgroundPixmap(wp, wp->bgpixmap, x, y,
 				width, height);
 		} else {
+//*REM*/screen driver will draw alpha values into the global alpha map.
+/*REM*/ #if defined(TRANS_COLOR)
+/*REM*/	                if ((MWA(wp->background)==0)||(wp->props & GR_WM_PROPS_APPMASK && wp->children && MWA(wp->children->background)==0))
+/*REM*/	                  GdSetAlphaChannel(wp->alpha,wp->x,wp->y,wp->width,wp->height);
+/*REM*/                 else 
+/*REM*/	                  GdSetAlphaChannel(NULL,0,0,0,0); 
+/*REM*/ #endif
 			GdFillRect(wp->psd, wp->x + x, wp->y + y, width,height);
 		}
 	}
@@ -598,8 +650,10 @@
 	/*
 	 * Now do the exposure if required.
 	 */
-	if (exposeflag)
+	if (exposeflag){
 		GsDeliverExposureEvent(wp, x, y, width, height);
+		//printf("GsDeliverExposureEvent(%d, %d, %d, %d, %d)\n",wp->id, x, y, width, height);
+	}
 }
 
 /*
@@ -648,6 +702,278 @@
 		GsExposeArea(wp, rootx, rooty, width, height, stopwp);
 }
 
+
+//*REM BEGIN*/
+#if defined(TRANS_COLOR)
+/*
+ * This function is a smaller version of GsWpClearWindow. I expects correct  
+ * values and is introduced for GsClearAreaUpAndDown which is responsible        
+ * for all the checking and clipping stuff.
+ */
+void
+GsWpSmartClearWindow(GR_WINDOW *wp, MWRECT AreaToDraw, GR_BOOL exposeflag)
+{
+	if (!wp->realized || !wp->output)
+		return;
+
+	GR_COORD x, y;
+
+	if(/*wp->parent*/0)
+	  {
+            x= AreaToDraw.left-wp->parent->x;
+	    y= AreaToDraw.top-wp->parent->y;
+	  }
+	else
+	  {
+            x= AreaToDraw.left-wp->x;
+	    y= AreaToDraw.top-wp->y;
+	  }
+	/*
+	 * All the clipping stuf have to be done somwhere before
+	 * At this point we expect apsolute correct values
+	 */
+
+	/*
+	 * Draw the background of the window.
+	 * Invalidate the current graphics context since
+	 * we are changing the foreground color and mode.
+	 */
+	curgcp = NULL;
+
+	GdSetFillMode(GR_FILL_SOLID);
+
+	if (!(wp->props & GR_WM_PROPS_NOBACKGROUND)) {
+		GdSetMode(GR_MODE_COPY);
+		GdSetForegroundColor(wp->psd, wp->background);
+		if (wp->bgpixmap) {
+		        //screen driver will draw alpha values into the global alpha map.
+                        if ((MWA(wp->background)==0)||(wp->props & GR_WM_PROPS_APPMASK && wp->children && MWA(wp->children->background)==0))
+                          GdSetAlphaChannel(wp->bgpixmap->alpha,wp->x,wp->y,wp->bgpixmap->width,wp->bgpixmap->height);
+			else 
+                          GdSetAlphaChannel(NULL,0,0,0,0); 
+			GsWpDrawBackgroundPixmap(wp, wp->bgpixmap, x, y,
+				   AreaToDraw.right-AreaToDraw.left /*width*/, AreaToDraw.bottom-AreaToDraw.top /*height*/);
+		} else {
+                        //screen driver will draw alpha values into the global alpha map.
+                        if ((MWA(wp->background)==0)||(wp->props & GR_WM_PROPS_APPMASK && wp->children && MWA(wp->children->background)==0))
+		          GdSetAlphaChannel(wp->alpha,wp->x,wp->y,wp->width,wp->height);
+		        else 
+		          GdSetAlphaChannel(NULL,0,0,0,0); 
+			GdFillRect(wp->psd, AreaToDraw.left/*wp->x + x*/, AreaToDraw.top /*wp->y + y*/,
+				   AreaToDraw.right-AreaToDraw.left /*width*/, AreaToDraw.bottom-AreaToDraw.top /*height*/);
+		}
+	}
+
+	/*
+	 * Now do the exposure if required.
+	 */
+	if (exposeflag){
+	        GsDeliverExposureEvent(wp,  AreaToDraw.right-wp->x/*x*/, AreaToDraw.top-wp->y/*y*/,
+				       AreaToDraw.left-AreaToDraw.right /*width*/, AreaToDraw.bottom-AreaToDraw.top /*height*/);
+		//printf("GsDeliverExposureEvent(%d, %d, %d, %d, %d)\n",wp->id, x, y, width, height);
+	}
+}
+
+
+
+/*  Quick and dirty stolen from devrgn.c
+ *  
+ *  1 if two RECTs overlap.
+ *  0 if two RECTs do not overlap.
+ */
+#define OVERLAP(r1, r2)           \
+	(r1.right  > r2.left  && \
+	 r1.left   < r2.right && \
+	 r1.bottom > r2.top    && \
+	 r1.top    < r2.bottom)
+
+/*
+ * This function clears the window itself in the specified area, all children
+ * and all overlaping lower windows. Following example tree 
+ * describes the way:
+ * 
+ *
+ *
+ *
+ *    R
+ *    ^
+ *    |
+ *    W <- w <- w <-
+ *    ^
+ *    |
+ *    W <- W <- w <- w
+ *         ^
+ *         |
+ *         W <- WP <- w <- w
+ *         ^    ^ 
+ *         |    | 
+ *         |    W <- W <- W <-W
+ *         |         |        |
+ *         |         |        W <- W <- W
+ *         |         |
+ *         |         W <- W <- W <- W
+ *         |      
+ *         |      
+ *         W <- W <- W
+ *                
+ *                
+ * WP: Start window    
+ * W : Window is redrawn
+ * w : Window is not redrawn
+ * R : Root window
+ *                
+ * This function handles redrawing windows with transparent background.
+ * so we stop with the first parent with a non transparent window.    
+ *     
+ *     
+ */               
+
+void
+GsWpClearWindowUpAndDown(GR_WINDOW *wp, GR_COORD x, GR_COORD y, GR_SIZE width,
+			 GR_SIZE  height, GR_BOOL exposeflag)
+{
+	if (!wp->realized || !wp->output)
+		return;
+
+	GR_WINDOW *pwp=NULL;
+	/*
+	 * Reduce the arguments so that they actually lie within the window.
+	 */
+	if (x < 0) {
+		width += x;
+		x = 0;
+	}
+	if (y < 0) {
+		height += y;
+		y = 0;
+	}
+	if (x + width > wp->width)
+		width = wp->width - x;
+	if (y + height > wp->height)
+		height = wp->height - y;
+
+	/*
+	 * Now see if the region is really in the window.  If not, then
+	 * do nothing.
+	 */
+	if ((x >= wp->width) || (y >= wp->height) || (width <= 0) ||
+		(height <= 0))
+			return;
+
+	//describe it in a rectangle
+	MWRECT AreaToDraw={x+wp->x,y+wp->y,x+wp->x+width,y+wp->y+height};
+
+	//init call
+	GsSetClipWindowPart(NULL, NULL, 0,&AreaToDraw);
+
+	//clear me, all childs, all siblings and parents+childs
+	pwp=wp;
+	while(pwp)
+	  {
+	    GR_WINDOW *wpt=NULL;
+	    if(pwp==wp)GsWpClearWpAndChilds(pwp, AreaToDraw, exposeflag, GR_MODE_WPCLEAR_WP2CLR);
+	    else GsWpClearWpAndChilds(pwp, AreaToDraw, exposeflag, GR_MODE_WPCLEAR_PARENT);
+
+	    for (wpt = pwp->siblings; wpt; wpt = wpt->siblings)
+	      {
+		GsWpClearWpAndChilds(wpt, AreaToDraw, exposeflag,GR_MODE_WPCLEAR_SIBLING);
+	      }	
+
+	    /* if pwp has a transparent bg, or pwp is a container window whose child has a transparent bg, we have to go on.*/
+	    if ((MWA(pwp->background)==0)||(pwp->props & GR_WM_PROPS_APPMASK && pwp->children && MWA(pwp->children->background)==0))
+	      pwp=pwp->parent;
+	    else
+	      break;
+	  }
+}
+
+void
+GsWpClearWpAndChilds(GR_WINDOW *wp, MWRECT AreaToDraw, GR_BOOL exposeflag, int flags)
+{
+	static char LastChildFound=0;
+	static GR_WINDOW *lastwp=NULL;
+
+	GR_WINDOW *sibwp=NULL;
+
+	if (!wp->realized || !wp->output)
+	  return;
+
+	//describe it in a rectangle
+	MWRECT AreaOfwp={wp->x,wp->y,wp->x+wp->width,wp->y+wp->height};
+
+
+	if(flags&GR_MODE_WPCLEAR_WP2CLR)
+	  {
+	    LastChildFound=0;
+	    lastwp=NULL;
+	  }
+
+	if(!OVERLAP(AreaOfwp,AreaToDraw))
+	   return;
+
+	//calc overlaping parts
+	//left side
+	if(AreaToDraw.left<AreaOfwp.left)
+	  AreaToDraw.left=AreaOfwp.left;
+	if(AreaToDraw.left>AreaOfwp.right) 
+	  return; //we are outside
+	//right side
+	if(AreaToDraw.right>AreaOfwp.right)
+	  AreaToDraw.right=AreaOfwp.right;
+	if(AreaToDraw.right<AreaOfwp.left) 
+	  return; //we are outside
+	//top
+	if(AreaToDraw.top<AreaOfwp.top)
+	  AreaToDraw.top=AreaOfwp.top;
+	if(AreaToDraw.top>AreaOfwp.bottom) 
+	  return; //we are outside
+	//bottom
+	if(AreaToDraw.bottom>AreaOfwp.bottom)
+	  AreaToDraw.bottom=AreaOfwp.bottom;
+	if(AreaToDraw.bottom<AreaOfwp.top) 
+	  return; //we are outside
+
+	/*
+	 * First do it for all the children. 
+	 * Except we just went up, in this case we already did it for all children. 
+	 */
+	
+	if(!(flags&GR_MODE_WPCLEAR_PARENT))
+	  {
+	    for (sibwp = wp->children; sibwp; sibwp = sibwp->siblings)
+	      {
+		//FIXME: check background and stop?
+		GsWpClearWpAndChilds(sibwp, AreaToDraw, exposeflag,GR_MODE_WPCLEAR_CHILD);
+	      }	
+	    
+	  }
+	/*
+	 * Check if we are the most top and right window in the tree 
+	 */
+	//set clip window
+	if((!wp->children && !LastChildFound)||(flags&GR_MODE_WPCLEAR_WP2CLR && !LastChildFound))
+	  {
+	    LastChildFound=1;
+	    /* 
+	     * We are the last child, so we call GsSetClipWindowPart the first time. 
+	     * In this case we have to clip aout all overlaping parents, too.
+	     *
+	     */
+	    GsSetClipWindowPart(wp, NULL, 0,&AreaToDraw);
+	  }
+
+	//clear window itself
+	GsWpSmartClearWindow(wp, AreaToDraw, exposeflag);
+
+	//prepare for next drawing
+	GsSetClipWindowPart(wp, NULL, GR_MODE_THISWP|GR_MODE_EXCLUDECHILDREN, &AreaToDraw);
+	lastwp=wp;
+}
+#endif
+//*REM END*/
+
+
+
 /*
  * Draw the border of a window if there is one.
  * Note: To allow the border to be drawn with the correct clipping,
@@ -687,7 +1013,8 @@
 
 	clipwp = NULL;
 	/* FIXME: window clipregion will fail here */
-	GsSetClipWindow(wp, NULL, 0);
+	/* REM: FIXME: may be we could use RToClip*/ 
+	GsSetClipWindow(wp, NULL, 0,/*REM*/NULL);
 	curgcp = NULL;
 	GdSetMode(GR_MODE_COPY);
 	GdSetForegroundColor(wp->psd, wp->bordercolor);
@@ -708,7 +1035,7 @@
 
 	/*
 	 * Restore the true window size.
-	 * Forget the currently clipped window since we messed it up.
+	 * Forget the currently clipped window since we messed it up
 	 */
 	wp->x += bs;
 	wp->y += bs;
@@ -926,7 +1253,7 @@
  * GR_DRAW_TYPE_NONE if an error is generated, or if drawing is useless.
  */
 GR_DRAW_TYPE
-GsPrepareDrawing(GR_DRAW_ID id, GR_GC_ID gcid, GR_DRAWABLE **retdp)
+GsPrepareDrawing(GR_DRAW_ID id, GR_GC_ID gcid, GR_DRAWABLE **retdp,/*REM*/MWRECT *RelAreaToDraw)
 {
 	GR_WINDOW	*wp;		/* found window */
         GR_PIXMAP       *pp;            /* found pixmap */
@@ -971,6 +1298,11 @@
 				GdIntersectRegion(reg, reg, regionp->rgn);
 		}
 		GdSetClipRegion(pp->psd, reg);
+		//*REM*/We reset the Clipmap since clipping the pixmap is not usefull here.
+		/*REM*/ #if defined(TRANS_COLOR)
+		/*REM*/ GdSetClipMap(NULL);
+		/*REM*/ #endif
+
 #else
 		{
 		MWCLIPRECT	cliprect;
@@ -1009,21 +1341,47 @@
 			 */
 			if (regionp && (gcp->xoff || gcp->yoff)) {
 				MWCLIPREGION *local = GdAllocRegion();
-
+				//*REM/FIXME: use RToClip here
 				GdCopyRegion(local, regionp->rgn);
 				GdOffsetRegion(local, gcp->xoff, gcp->yoff);
 
 				GsSetClipWindow(wp, local,  
-					gcp->mode & ~GR_MODE_DRAWMASK);
-
+						gcp->mode & ~GR_MODE_DRAWMASK/*REM*/,NULL);
 				GdDestroyRegion(local);
 			  } else {
+			        /*REM*/MWRECT AreaToDraw;
+				/*REM*/if(RelAreaToDraw) {
+				/*REM*/  AreaToDraw.left=RelAreaToDraw->left+wp->x;
+				/*REM*/  AreaToDraw.top =RelAreaToDraw->top+wp->y;
+				/*REM*/  AreaToDraw.right=RelAreaToDraw->right+wp->x;
+				/*REM*/  AreaToDraw.bottom=RelAreaToDraw->bottom+wp->y;
+				/*REM*/}
 				GsSetClipWindow(wp, regionp? regionp->rgn: NULL,
-					gcp->mode & ~GR_MODE_DRAWMASK);
+						gcp->mode & ~GR_MODE_DRAWMASK,
+						/*REM*/RelAreaToDraw?&AreaToDraw:NULL
+						);
 			  }
 		}
 	}
 
+//*REM*/We have to set the global alpha map here.
+//*REM*/Screen driver will draw alpha values into the global alpha map.
+/*REM*/ #if defined(TRANS_COLOR)
+/*REM*/ if(wp)
+/*REM*/ {
+/*REM*/	  if ((MWA(wp->background)==0)||(wp->props & GR_WM_PROPS_APPMASK && wp->children && MWA(wp->children->background)==0))
+/*REM*/	    GdSetAlphaChannel(wp->alpha,wp->x,wp->y,wp->width,wp->height);
+/*REM*/   else 
+/*REM*/	    GdSetAlphaChannel(NULL,0,0,0,0); 
+/*REM*/ }
+/*REM*/ if(pp)
+/*REM*/ {
+//*REM*/    if(MWA(pp->background))  GdSetAlphaChannel(NULL,0,0,0,0);
+//*REM*/    else GdSetAlphaChannel(pp->alpha,pp->x,pp->y,pp->width,pp->height);
+/*REM*/    GdSetAlphaChannel(pp->alpha,pp->x,pp->y,pp->width,pp->height);
+/*REM*/ }
+/*REM*/ #endif	
+
 	/*
 	 * If the graphics context has been changed, then tell the
 	 * device driver about it.
@@ -1106,9 +1464,23 @@
 
 	if (wp != clipwp) {
 		/* FIXME: no user region clipping here*/
-		GsSetClipWindow(wp, NULL, 0);
+	        /* REM: FIXME: may be we could use RToClip*/ 
+	  GsSetClipWindow(wp, NULL, 0/*REM*/,NULL);
 	}
 
+
+//*REM*/set current alpha map
+//*REM*/screen driver will draw alpha values into the global alpha map.
+/*REM*/ #if defined(TRANS_COLOR)
+/*REM*/ if(wp) 
+/*REM*/  {
+/*REM*/	  if ((MWA(wp->background)==0)||(wp->props & GR_WM_PROPS_APPMASK && wp->children && MWA(wp->children->background)==0))
+/*REM*/	    GdSetAlphaChannel(wp->alpha,wp->x,wp->y,wp->width,wp->height);
+/*REM*/   else 
+/*REM*/	    GdSetAlphaChannel(NULL,0,0,0,0); 
+/*REM*/  }
+/*REM*/ #endif	
+
 	return wp;
 }
 
